/*
* ISR Interface Example.
* 
* This is the implementation of the external portion of the ISR example.
*/


#define MAKE_EXTERN
#include "ISR_Interface_SUN5T.h"

#include <semaphore.h>

int ISRFired;
int ISRCounter;
/*
   Save the actor and it's wakeup function upon registration.  This actor's
   wakeup function will be used to wakeup the sleeping controller, if
   required, when the ISR is called.
*/

static sem_t *wakeupSem = (sem_t *) 0;


MAKE_EXTERN void registerWakeupWithISR( sem_t *sem )
{
    wakeupSem = sem;
}
		 


void  anISR( void )
{

   int returnStatus = 0;

printf("in ISR ISRFired=%d\n", ISRFired ); 

   /*
      This function is the one actually called by the interrupt.
   */
   if ( wakeupSem )
   {
printf("in ISR wakeupSem \n");

       ISRCounter++;

       /*
          Only need to wake up controller if the layer actor has "processed"
          the interrupt.  If it has been processed, then there is a chance
          that the controller may be sleeping (no messages to be delivered).
       */
       if (ISRFired == 0 )
       {
           returnStatus = sem_post ( wakeupSem );
	   if ( returnStatus != 0)
	       printf("sem_post error\n");
	   ISRFired = 1;
       }
   }
}

