/*
* ISR Interface Example.
* 
* This is the implementation of the external portion of the ISR example.
*/


#define MAKE_EXTERN
#include "ISR_Interface_Tornado.h"

#include "vxWorks.h"
#include "semLib.h"


int ISRFired;
int ISRCounter;
/*
   Save the actor and it's wakeup function upon registration.  This actor's
   wakeup function will be used to wakeup the sleeping controller, if
   required, when the ISR is called.
*/

static SEM_ID wakeupSem = (SEM_ID) 0;


MAKE_EXTERN void registerWakeupWithISR( SEM_ID sem )
{
    logMsg( "registerWakeupWithISR called\n", 0, 0, 0, 0 ,0 ,0 );
    wakeupSem = sem;
}



void  watchdogServiceRoutine( void )
{

   STATUS returnStatus = 0;

   /*
      This function is the one actually called by the interrupt.
   */
   logMsg( "watchdogServiceRoutine fired!\n", 0, 0, 0, 0 ,0 ,0 );
   if ( wakeupSem )
   {
       ISRCounter++;

       /*
          Only need to wake up controller if the layer actor has "processed"
          the interrupt.  If it has been processed, then there is a chance
          that the controller may be sleeping (no messages to be delivered).
       */
       if (ISRFired == 0 )
       {
           returnStatus = semGive ( wakeupSem );
	       if ( returnStatus == ERROR) {
	           logMsg("semGive error\n", 0, 0, 0, 0, 0, 0);
           }
           ISRFired = 1;
       }
   }
}

